# include <fstream.h>
# include <conio.h>
# include <stdlib.h>
# include <string.h>
# include <dos.h>
# include <io.h>

# define binary_input  129
# define binary_output  130
# define binary_io  131
# define binary_append  136
# define text_input  1
# define text_output  2

int *dep_list;
int dep_count = 0;


struct 	Sotrudnik {
  int no;
  char fio [ 16 ];
  int strNo;
  int godR;
  char pol;
  char dl [ 10 ];
  int oklad;
  char postupil [ 12 ]; };
Sotrudnik  sotrud;
int sotr_size = sizeof ( Sotrudnik );
char table [ 7 ] [ 80 ] =
{ "      㤭                                              ",
  "ͻ",
  " N                   .                                   ",
  "⤳     ...       . ஦.       㯨 ",
  "                                                               ",
  "͹",
  "ͼ"};
ofstream res_file, screen;
ifstream keyboard ( "con" );
fstream fin;
fstream fout;
char *res_filename = "res.dat", dat_filename [ 15 ];


//-------- ஡  砫   ப
void filtr ( char *Stroka )
{
  char 	Source [ 255 ] = "";
  int Xl = 0;
  int Xr = strlen ( Stroka ) - 1;
  while ( Stroka [ Xl ++ ] == ' ' );
    while ( Stroka [ Xr -- ] == ' ' );
      Xl -= 1;
  for ( int x = Xl; x <= Xr + 1; x ++ )
    Source [ x - Xl ] = Stroka [ x ];
  Source [ x ] = '\0';
  strcpy ( Stroka, Source );
}

// 뢮  
ofstream& operator << ( ofstream& out_stream, Sotrudnik& s )
{
  out_stream << '';
  out_stream.width ( 3 ); out_stream << s.no << '';
  out_stream.width ( 17 ); out_stream << s.fio << '';
  out_stream.width ( 5 ); out_stream << s.strNo << '';
  out_stream.width ( 5 ); out_stream << s.godR << '';
  out_stream.width ( 3 ); out_stream << s.pol << '';
  out_stream.width ( 12 ); out_stream << s.dl << '';
  out_stream.width ( 7 ); out_stream << s.oklad << '';
  out_stream.width ( 11 ); out_stream << s.postupil << '';
  out_stream << '\n'; out_stream.flush(); return out_stream;
}


// ஢ઠ  ⢮ ⤥  ஬ num
int Dep_exists ( int num )
{
  int ret_val, i;  ret_val = 0;
  for ( i = 0; i < dep_count; i ++ )
    if ( dep_list [ i ] == num ) ret_val = 1;
  return ret_val;
}

//  ⤥
void Dep_add ( int num )
{
  int *temp_list, i;
  temp_list = new int [ dep_count ];
  for ( i = 0; i < dep_count; i ++ ) temp_list [ i ] = dep_list [ i ];
  delete dep_list; dep_list = new int [ dep_count + 1 ];
  for ( i = 0; i < dep_count; i ++ ) dep_list [ i ] = temp_list [ i ];
  dep_list [ dep_count ] = num; dep_count ++; delete temp_list;
}

// ।  䠩, 室   ⤥
char* bin_filename ( int num )
{
  char *ret_val, temp_string [ 10 ];
  strcpy ( ret_val, "Dep" );
  itoa ( num, temp_string, 10 );
  strcat ( ret_val, temp_string );
  strcat ( ret_val, ".typ" );
  return ret_val;
}

// ⥭ ⥪⮢ 䠩   
void make_bin ( char * fn, int s )
{
  ifstream dat_file;
  dat_file.open ( fn, text_input );
  if ( dat_file == 0 ) {
    clrscr (); cout << "訡  ⨨ 䠩 !!"; getch ();
    exit ( 0 );
  }
  while ( dat_file.eof () == 0 ) {
    dat_file >> sotrud.no;
    if ( dat_file.eof () ) break;
    if ( Dep_exists ( sotrud.no ) )
      fout.open ( bin_filename ( sotrud.no ), binary_append );
      else {
	fout.open ( bin_filename ( sotrud.no ), binary_output );
	Dep_add ( sotrud.no );
      }
    dat_file.get ( sotrud.fio, 18 );
    filtr ( sotrud.fio );
    dat_file >> sotrud.strNo; dat_file >> sotrud.godR;
    dat_file >> sotrud.pol;   dat_file >> sotrud.dl;
    dat_file >> sotrud.oklad; dat_file >> sotrud.postupil;
    fout.write ( ( char* ) &sotrud, sotr_size );
    if ( s ) {
      screen << sotrud; res_file << sotrud;
    }
    fout.flush ();
    fout.close ();
  }
  dat_file.close ();
}

// 뢮 蠯
void print_table ()
{
  int i;
  for ( i = 0; i < 6; i ++ ) {
    res_file << table [ i ] << '\n';
    cout << table [ i ] << '\n';
  }
}


// ஫   楫 ᫠
int get_integer ( int x0, int y0 )
{
  unsigned char ch;
  char temp_string [ 6 ];
  int k = 0;
  gotoxy ( x0, y0 );
  do
   {
    ch = getch ();
    if ( ch == 8 )
     {
      if ( k == 0 ) continue;
      temp_string [ k - 1 ] = '\0'; gotoxy ( x0, y0 ); clreol ();
      cout << temp_string; k --;
     }
    if ( ch > 47 && ch < 58 )
     {
      temp_string [ k ] = ch; cout << ch; k ++; continue;
     }
   } while ( ch != 13 );
  temp_string [ k ] = '\0';
  return ( atoi ( temp_string ) );
}

// ᬮ 
void view_otdel ()
{
  int d, i;
  clrscr ();
  do {
   cout << "㤭  ⤥ ᬮ?\n";
   cout << " ⤥: ";
   for ( i = 0; i < dep_count; i ++ )
     if ( i + 1 < dep_count ) screen << dep_list [ i ] << ", ";
       else screen << dep_list [ i ] << ". \n";
   screen.flush ();
   d = get_integer ( 1, 5 ); clrscr ();
   if ( ! Dep_exists ( d ) ) cout << "\n ⤥  !\n";
  } while ( ! Dep_exists ( d ) );
  fin.open ( bin_filename ( d ), binary_input );
  clrscr ();
  print_table ();
  while ( fin.read ( (char*)&sotrud, sotr_size ) )
   {
    screen << sotrud;
    res_file << sotrud;
   }
  fin.close ();
  cout << table [ 6 ];
  res_file << table [ 6 ];
}

// ।  㤭  ६ sotrud
int vozrast ()
{
  date d;
  getdate ( &d );
  return ( d.da_year - sotrud.godR );
}

// । । 
void sred_vozrast ()
{
  float sum = 0, k = 0;
  int d, i;
  clrscr ();
  do {
    cout << "।  㤭  ⤥ ?\n";
    cout << "( Enter - ।  ᥣ । )\n";
    cout << " ⤥: ";
    for ( i = 0; i < dep_count; i ++ )
      if ( i + 1 < dep_count ) screen << dep_list [ i ] << ", ";
	else screen << dep_list [ i ] << ". \n"; screen.flush ();
    d = get_integer ( 1, 6 ); clrscr ();
    if ( ! Dep_exists ( d ) ) cout << "\n ⤥  !\n";
  } while ( ( ! Dep_exists ( d ) ) && ( d != 0 ) );
  if ( d == 0 ) goto all;
  fin.open ( bin_filename ( d ), binary_input );
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
    sum += vozrast ();
    k ++;
  }
  sum /= k;
  fin.close ();
  clrscr ();
  cout << "\n।  㤭 ⤥ " << d << " ࠢ ";
  cout.precision ( 2 ); cout << sum;
  res_file << "\n।  㤭 ⤥ " << d << " ࠢ ";
  res_file.precision ( 5 ); res_file << sum;
  return;
all:
  for ( d = 0; d < dep_count; d ++ ) {
    fin.open ( bin_filename ( dep_list [ d ] ), binary_input );
    while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
      sum += vozrast ();
      k ++;
    }
    fin.close ();
  }
  sum = sum / k;
  clrscr ();
  cout << "\n।  㤭 । ࠢ ";
  cout.precision ( 2.2 ); cout << sum;
  res_file << "\n।  㤭 । ࠢ ";
  res_file.precision ( 2.2 ); res_file << sum;
}

// ।   㤭
void opr_vozrast ()
{
  int 	k, dep_num, v, i;
  char 	tfio [ 16 ];
  clrscr ();
  do {
    cout << "\n  ⤥:\n";
    cout << " ⤥: ";
    for ( i = 0; i < dep_count; i ++ )
     if ( i + 1 < dep_count ) screen << dep_list [ i ] << ", ";
      else screen << dep_list [ i ] << ". \n";
    screen.flush ();
    dep_num = get_integer ( 1, 6 ); clrscr ();
    if ( ! Dep_exists ( dep_num ) ) cout << "\n ⤥  !\n";
  } while ( ! Dep_exists ( dep_num ) );
  clrscr ();
  cout << "\n : \n\n";
  cout << " 㤭: \n";
  fin.open ( bin_filename ( dep_num ), binary_input );
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) )
    screen << sotrud.fio << '\n';
  screen << '\n';  screen.flush ();
  fin.close (); cin.getline ( tfio, 16, '\n' );
  clrscr ();
  res_file << "\n।  ⮢ " << tfio << '\n';
  fin.open ( bin_filename ( dep_num ), binary_input );  k = 0;
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) )
    if ( ! strcmp ( tfio, sotrud.fio ) ) {
      v = vozrast ();
      cout << "\n ⮢ " << tfio << " ࠢ " << v << "\n";
      res_file << "\n ⮢ " << tfio << " ࠢ " << v << "\n";
      k = 1;
    }
  if ( k == 0 ) {
    cout << "\n㤭  !!";
    res_file << "\n㤭  !!";
  }
  fin.close ();
  cout << "\n Enter...\n";
}

// 䨪    ௫.
void modif ()
{
  int 	k, dep_num, i;
  int 	noklad;
  char 	tdl [ 10 ], key;
  int   toklad;
  char  filename [ 10 ];
  clrscr ();
  keyboard.close ();
  keyboard.open ( "con" );
  cout << "1. 䨪  䠩\n";
  cout << "2. 䨪  \n";
  do  key = getch ();  while ( key < '1' || key > '2' );
  if ( key == '1' ) {
    clrscr ();
    cout << "  䠩:\n";
    keyboard >> filename;  clrscr ();
    ifstream mod_file;
    mod_file.open ( filename, text_input );
    if ( mod_file == 0 ) {
      cout << "\n୮  䠩!\n";
      return;
    }
    while ( mod_file.eof () == 0 ) {
      mod_file >> dep_num;
      if ( mod_file.eof () ) break;
      mod_file >> tdl;
      mod_file >> toklad;
      mod_file >> noklad;
      fin.open ( bin_filename ( dep_num ), binary_io ); k = 0;
      while ( fin.read ( ( char * ) &sotrud, sotr_size ) )
	if ( ( ! strcmp ( tdl, sotrud.dl ) ) && ( toklad == sotrud.oklad ) )
	 {
	  k ++; screen << "䨪:\n"; screen << sotrud;
	  sotrud.oklad = noklad; screen << sotrud;
	  fin.seekp ( fin.tellp () - sotr_size );
	  fin.write ( ( char * ) &sotrud, sotr_size );
	 }
      if ( k == 0 )  cout << dep_num << " " << tdl << " " << toklad
			  << " -   !\n";
      fin.close ();
    }
    mod_file.close ();
    cout << "\n䨪 襭!\n";
    return;
  }
  res_file << "\n䨪:\n";
  do
   {
    cout << "\n  ⤥:\n";
    cout << " ⤥: ";
    for ( i = 0; i < dep_count; i ++ )
      if ( i + 1 < dep_count ) cout << dep_list [ i ] << ", ";
	else cout << dep_list [ i ] << ". \n";
    cout.flush ();
    dep_num = get_integer ( 1, 6 ); clrscr ();
    if ( ! Dep_exists ( dep_num ) ) cout << "\n ⤥  !\n";
   } while ( ! Dep_exists ( dep_num ) );
  clrscr ();
  cout << "\n : \n\n";
  cout << "  (   ): \n";
  fin.open ( bin_filename ( dep_num ), binary_input );
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
    filtr ( sotrud.dl );
    cout.width ( 12 );
    cout << sotrud.dl << "  -  ";
    cout << sotrud.oklad << '\n';
  }
  cout << '\n'; cout.flush (); fin.close ();
  keyboard.getline ( tdl, 10, '\n' );
  cout << "\n   ᪠:\n";
  keyboard >> toklad;
  fin.open ( bin_filename ( dep_num ), binary_io ); k = 0;
  res_file << "\n饬  " << tdl << "   " << toklad << '\n';
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) )
    if ( ( ! strcmp ( tdl, sotrud.dl ) ) && ( toklad == sotrud.oklad ) ) {
      screen << sotrud;
      res_file << sotrud;
      cout << "쪮 ⥯   㤥  ⮢ " << sotrud.fio
	   << "?   ";
      cin >> noklad;
      k = 1;
      res_file << '\n';
      sotrud.oklad = noklad;
      screen << sotrud;
      res_file << sotrud;
      fin.seekp ( fin.tellp () - sotr_size );
      fin.write ( ( char * ) &sotrud, sotr_size );
    }
  if ( k == 0 ) {
    cout << "\n㤭  !!";
    res_file << "\n㤭  !!";
  }
  fin.close ();
  cout << "\n Enter...\n";
}

// .
void dop ()
{
  char key;
  int i;
  clrscr ();
  cout << "1.   䠩\n";
  cout << "2.   \n";
  do  key = getch (); while ( key < '1' || key > '2' );
  if ( key == '1' ) {
    cout << "\n\n  䠩: ";
    char filename [ 10 ];
    keyboard >> filename;
    res_file << "\n\n   䠩 " << filename << "...";
    fin.open ( filename, text_input );
    if ( fin ) {
      fin.close ();
      make_bin ( filename, 1 );
      res_file << "\n 襭.\n";
      cout << "\n 襭.";
    }
      else {
	cout << "\n୮  䠩!";
	res_file << "\n୮  䠩!\n";
      }
    return;
  }
  clrscr ();
  do {
    cout << "  ⤥:\n";
    cout << " ⤥: ";
    for ( i = 0; i < dep_count; i ++ )
     if ( i + 1 < dep_count ) cout << dep_list [ i ] << ", ";
      else cout << dep_list [ i ] << ". \n";
    sotrud.no = get_integer ( 1, 6 ); clrscr ();
  } while ( sotrud.no < 1 );
  do {
    clrscr (); cout << " :\n";
    keyboard.getline ( sotrud.fio, 16, '\n' );
  } while ( strlen ( sotrud.fio ) < 1 || strlen ( sotrud.fio ) > 16 );
  do {
    clrscr (); cout << " 客 :\n";
    sotrud.strNo = get_integer ( 1, 2 );
  } while ( sotrud.strNo < 1 || sotrud.strNo > 9999 );
  do {
    clrscr (); cout << "  ஦:\n";
    sotrud.godR = get_integer ( 1, 2 );
  } while ( sotrud.godR < 1900 || sotrud.godR > 9999 );
  do {
    clrscr (); cout << "  ( ''  '' ):\n";
    sotrud.pol = getch ();
  } while ( sotrud.pol != '' && sotrud.pol != '' );
  do {
    clrscr (); cout << " :\n";
    keyboard >> sotrud.dl;
  } while ( strlen ( sotrud.dl ) < 1 || strlen ( sotrud.dl ) > 10 );
  do {
    clrscr (); cout << " :\n";
    sotrud.oklad = get_integer ( 1, 2 );
  } while ( sotrud.oklad < 1 || sotrud.oklad > 32000 );
  do {
    clrscr (); cout << "  㯫 ( .. ):\n";
    keyboard >> sotrud.postupil;
  } while ( strlen ( sotrud.postupil ) < 6 || strlen ( sotrud.postupil ) > 10 );
  do {
    clrscr (); res_file << "\n :\n"; screen << sotrud;
    res_file << sotrud; cout << "  ( y/n )?"; key = getch ();
  } while ( key != 'y' && key != 'n' );
  if ( key == 'y' ) {
    if ( ! Dep_exists ( sotrud.no ) ) {
      fout.open ( bin_filename ( sotrud.no ), binary_output );
      Dep_add ( sotrud.no );
    } else fout.open ( bin_filename ( sotrud.no ), binary_append );
    fout.write ( ( char * ) &sotrud, sotr_size );
    res_file << "\n !\n";
    cout << "\n !\n";
    fout.close ();
  } else {
      res_file << "\n⪠  .\n";
      cout << "\n⪠  .\n";
    }
}

//  ᥩ  客 .
void udalenie ()
{
  int tsn, i, j = 0, dep_num;
  char key, filename [ 10 ];
  fstream f;
  clrscr ();
  cout << "1.   ,   䠩\n";
  cout << "2.   \n";
  do  key = getch ();  while ( key < 49 || key > 50 );
  if ( key == 49 ) {
    clrscr ();
    cout << "  䠩:\n";
    keyboard >> filename;
    fstream ud_file;
    ud_file.open ( filename, text_input );
    if ( ! ud_file ) {
      cout << "\n୮ 㪠 䠩!\n";  return;
    }
    clrscr ();
    while ( ! ud_file.eof () ) {
      ud_file >> dep_num;
      if ( ud_file.eof () ) break;
      ud_file >> tsn;
      fin.open ( bin_filename ( dep_num ), binary_input );
      f.open ( "tempfile.typ", binary_output ); j = 0;
      cout << " ᥩ  㤠:\n\n";
      while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
	if ( sotrud.strNo == tsn ) {
	  screen << sotrud;  res_file << sotrud; j ++;
	  cout << "\n 㤠!\n";
	  res_file << "\n 㤠!\n";
	  continue;
	}
	f.write ( ( char * ) &sotrud, sotr_size );
      }
      if ( j == 0 ) {
	cout << "\n  ᥩ  㤠.\n";
	res_file << "\n  ᥩ  㤠.\n";
      }
      fin.close ();
      f.close ();
      remove ( bin_filename ( dep_num ) );
      rename ( "tempfile.typ", bin_filename ( dep_num ) );
    }
    ud_file.close ();
    return;
  }
  do {
    cout << "  ⤥ 㤠?\n";
    cout << " ⤥: ";
    for ( i = 0; i < dep_count; i ++ )
     if ( i + 1 < dep_count ) cout << dep_list [ i ] << ", ";
      else cout << dep_list [ i ] << ". \n";
    i = get_integer ( 1, 6 ); clrscr ();
    if ( ! Dep_exists ( i ) ) cout << "\n ⤥  !\n";
  } while ( ! Dep_exists ( i ) );
  clrscr (); cout << "\n 客   㤠:\n";
  cout << " : \n";
  fin.open ( bin_filename ( i ), binary_input );
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) )
    cout << sotrud.strNo << '\n';
  cout << '\n'; cout.flush (); fin.close ();
  tsn = get_integer ( 1, wherey () );
  fin.open ( bin_filename ( i ), binary_input );
  f.open ( "tmp.typ", binary_output );
  res_file << "\n   客 ஬ " << tsn
	 << "  ⤥ " << i << '\n';
  clrscr (); cout << " ᥩ  㤠:\n\n";
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
    if ( sotrud.strNo == tsn ) {
      screen << sotrud; res_file << sotrud;
      j ++; res_file << "\n 㤠\n";
      cout << "\n 㤠!\n"; continue;
    }
    f.write ( ( char * ) &sotrud, sotr_size );
  }
  if ( j == 0 ) {
    cout << "\n  ᥩ  㤠.\n";
    res_file << "\n  ᥩ  㤠.\n";
  }
  fin.close (); f.close ();
  remove ( bin_filename ( i ) ); rename ( "tmp.typ", bin_filename ( i ) );
}

// । 業 ᨮ஢   ⤥.
void proc_pens_zad_otdela ()
{
  int dep_num, k = 0, kp = 0, i;
  do {
    cout << "  ⤥:\n";
    cout << " ⤥: ";
    for ( i = 0; i < dep_count; i ++ )
      if ( i + 1 < dep_count ) cout << dep_list [ i ] << ", ";
	else cout << dep_list [ i ] << ". \n";
    dep_num = get_integer ( 1, 6 ); clrscr ();
    if ( ! Dep_exists ( dep_num ) ) cout << "\n ⤥  !\n";
  } while ( ! Dep_exists ( dep_num ) );
  fin.open ( bin_filename ( dep_num ), binary_input );
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
    k ++;
    if ( ( sotrud.pol == '' ) && ( vozrast () >= 60 ) ) kp ++;
    if ( ( sotrud.pol == '' ) && ( vozrast () >= 55 ) ) kp ++;
  }
  clrscr ();
  res_file << "\n\n। 業 ᨮ஢  "
	   << dep_num << " ⤥:\n"; fin.close ();
  if ( kp == 0 ) {
    res_file << " " << dep_num << " ⤥   ᨮ஢.\n";
    cout << " " << dep_num << " ⤥   ᨮ஢.\n";
  }
  else {
    res_file << "業 ᨮ஢  " << dep_num << " ⤥\n"
	   << " 饣 ᫠ 㤭 ⠢ "
	   << 100 * kp / k << "%\n";
    cout << "業 ᨮ஢  " << dep_num << " ⤥\n"
	 << " 饣 ᫠ 㤭 ⠢ "
	 << 100 * kp / k << "%\n";
  }
}

// । 業 ᨮ஢    ⤥.
void proc_pens_zad_dolj_otdela ()
{
  int dep_num, k = 0, kp = 0, i;
  char tdl [ 12 ];
  do {
    cout << "  ⤥:\n";
    cout << " ⤥: ";
    for ( i = 0; i < dep_count; i ++ )
     if ( i + 1 < dep_count ) cout << dep_list [ i ] << ", ";
      else cout << dep_list [ i ] << ". \n";
    dep_num = get_integer ( 1, 6 ); clrscr ();
    if ( ! Dep_exists ( dep_num ) ) cout << "\n ⤥  !\n";
  } while ( ! Dep_exists ( dep_num ) );
  clrscr (); cout << " :\n";
  cout << " : \n";
  fin.open ( bin_filename ( dep_num ), binary_input );
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
    cout << sotrud.dl << '\n';
  }
  cout << '\n';
  cout.flush ();
  fin.close ();
  keyboard >> tdl;
  res_file << "\n\n饬  " << dep_num << " ⤥ ᨮ஢  "
	 << tdl << "...\n";
  fin.open ( bin_filename ( dep_num ), binary_input );
  while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
    if ( strcmp ( tdl, sotrud.dl ) ) continue;
    k ++;
    if ( ( sotrud.pol == '' ) && ( vozrast () >= 60 ) ) kp ++;
    if ( ( sotrud.pol == '' ) && ( vozrast () >= 55 ) ) kp ++;
  }
  fin.close ();
  clrscr ();
  if ( k == 0 ) {
    cout << "   " << dep_num << " ⤥  !";
    res_file << tdl << " - 訡筠 !\n";
    return;
  }
  if ( kp == 0 ) {
    res_file << " " << dep_num << " ⤥  ᨮ஢ "
	   << " '" << tdl << "'\n";
    cout << " " << dep_num << " ⤥  ᨮ஢ "
	   << " '" << tdl << "'\n";
  }
  else {
    res_file << "業 ᨮ஢  " << tdl << "  " << dep_num
	   << " ⤥ \n 饣 ᫠ 㤭 ⤥ ⠪  "
	   << "⠢ " << 100 * kp / k << "%\n";
    cout << "業 ᨮ஢  " << tdl << "  " << dep_num
	 << " ⤥ \n 饣 ᫠ 㤭 ⤥ ⠪  "
	 << "⠢ " << 100 * kp / k << "%\n";
  }
}

// । 業 ᨮ஢   ᥣ ।.
void proc_pens_zad_dolj_predpr ()
{
  int k = 0, kp = 0, i;
  char tdl [ 12 ];
  clrscr (); cout << " :\n";
  cout << " : \n";
  for ( i = 0; i < dep_count; i ++ ) {
    fin.open ( bin_filename ( dep_list [ i ] ), binary_input );
    while ( fin.read ( ( char * ) &sotrud, sotr_size ) )
      cout << sotrud.dl << '\n';
    fin.close ();
  }
  cout << '\n';
  cout.flush ();
  keyboard >> tdl;
  res_file << "\n\n饬  ।⨨ ᨮ஢  "
	 << tdl << "...\n";
  for ( i = 0; i < dep_count; i ++ ) {
    fin.open ( bin_filename ( dep_list [ i ] ), binary_input );
    while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
      if ( strcmp ( tdl, sotrud.dl ) ) continue;
      k ++;
      if ( ( sotrud.pol == '' ) && ( vozrast () >= 60 ) ) kp ++;
      if ( ( sotrud.pol == '' ) && ( vozrast () >= 55 ) ) kp ++;
    }
    fin.close ();
  }
  clrscr ();
  if ( k == 0 ) {
    cout << "   ।⨨  !";
    res_file << tdl << " - 訡筠 !\n"; return;
  }
  if ( kp == 0 ) {
    res_file << " ।⨨  ᨮ஢ "
	   << " '" << tdl << "'\n";
    cout << " ।⨨  ᨮ஢ "
	   << " '" << tdl << "'\n";
  } else {
      res_file << "業 ᨮ஢  " << tdl
	       << " \n 饣 ᫠ 㤭 ⠪  "
	       << "⠢ " << 100 * kp / k << "%\n";
      cout << "業 ᨮ஢  " << tdl
	   << " \n 饣 ᫠ 㤭 ⠪  "
	   << "⠢ " << 100 * kp / k << "%\n";
    }
}

// 冷祭 ⤥  浪 ⠭ ᫠ ᨮ஢.
void sort_otdels ()
{
  int i, j, temp;
  int *kp, *otd;
  otd = new int [ dep_count ];
  kp = new int [ dep_count ];
  for ( i = 0; i < dep_count; i ++ ) {
    otd [ i ] = dep_list [ i ];
    kp [ i ] = 0;
    fin.open ( bin_filename ( dep_list [ i ] ), binary_input );
    while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
      if ( ( sotrud.pol == '' ) && ( vozrast () >= 60 ) ) kp [ i ] ++;
      if ( ( sotrud.pol == '' ) && ( vozrast () >= 55 ) ) kp [ i ] ++;
    } fin.close ();
  }
  for ( i = 0; i < dep_count; i ++ )
    for ( j = i + 1; j < dep_count; j ++ )
      if ( kp [ i ] > kp [ j ] ) {
	temp = kp [ i ]; kp [ i ] = kp [ j ]; kp [ j ] = temp;
	temp = otd [ i ]; otd [ i ] = otd [ j ]; otd [ j ] = temp;
      }
  cout << "冷祭 ⤥   ᨮ஢:\n\n";
  cout << "⤥\t\t- ᨮ஢\n\n";
  res_file << "冷祭 ⤥   ᨮ஢:\n\n";
  res_file << "\t⤥\t\t- ᨮ஢\n\n";
  for ( i = 0; i < dep_count; i ++ ) {
    cout << "  " << otd [ i ] << "\t\t\t" << kp [ i ] << '\n';
    res_file << "  " << otd [ i ] << "\t\t\t" << kp [ i ] << '\n';
  } delete kp; delete otd;
}

// .
void sub_menu ()
{
  char key;
  textbackground ( 1 );
  textcolor ( 14 );
  do {
   clrscr();
   cout << "\n\n\t\t। 業 ᨮ஢...\n\n"
	<< "\t>  ⤥...............................1\n"
	<< "\t>    ⤥............2\n"
	<< "\t>    ।.......3\n"
	<< "\t> Enter - ᬮ \n"
	<< "\t> Esc - 室   ";
   key = getch ();
   switch ( key ) {
     case 49: clrscr(); proc_pens_zad_otdela (); getch();  break;
     case 50: clrscr(); proc_pens_zad_dolj_otdela (); getch();  break;
     case 51: clrscr(); proc_pens_zad_dolj_predpr (); getch (); break;
     case 13 : view_otdel (); getch (); break;
   }
  } while ( key != 27 );
  textbackground ( 1 );
  textcolor ( 11 );
}

//   ⥪⮢ 䠩
void refresh_textfile ()
{
  int i;
  ofstream dat_file;
  dat_file.open ( dat_filename, text_output );
  for ( i = 0; i < dep_count; i ++ ) {
    fin.open ( bin_filename ( dep_list [ i ] ), binary_input );
    while ( fin.read ( ( char * ) &sotrud, sotr_size ) ) {
      dat_file << sotrud.no;
      dat_file.width ( 17 );
      dat_file << sotrud.fio;
      dat_file.width ( 6 );
      dat_file << sotrud.strNo;
      dat_file.width ( 5 );
      dat_file << sotrud.godR;
      dat_file.width ( 2 );
      dat_file << sotrud.pol;
      dat_file.width ( 11 );
      dat_file << sotrud.dl;
      dat_file.width ( 6 );
      dat_file << sotrud.oklad;
      dat_file.width ( 12 );
      dat_file << sotrud.postupil;
      dat_file << '\n';
    }
  fin.close ();
  }
  dat_file.close ();
}

// ᭮ 㭪
void main ()
{
  char key;
  screen.open ( "con" );
  textbackground ( 1 );
  textcolor ( 11 );
  clrscr ();
  cout << "\n\n\t\t\t\tਠ 27.\n\n\n";
  cout << "\n\t\t⥬ ࠡ⪨   ᯥ 㤥⮢\n"
	  "\t\t              㯯 ⮪\n";
  cout << "\n\n\n\n\t\t⥬ ࠧࠡ⠫ 㤥 㯯  2-. ..........";
  cout << "\n\n\t\t  䠩 : ";
  cin >> dat_filename;
  res_file.open ( res_filename );
  make_bin ( dat_filename, 0 );
  _setcursortype ( _NOCURSOR );
  do {
    clrscr();
    cout << "\n\n\t\t\t:\n\n"
	 << "\t> । । ...........1\n"
	 << "\t> 䨪 ......................2\n"
	 << "\t> ..............................3\n"
	 << "\t> ................................4\n"
	 << "\t> ।  㤭........5\n"
	 << "\t> । 業 ᨮ஢........6\n"
	 << "\t> 冷祭 ⤥....................7\n"
	 << "\t> Enter - ᬮ \n"
	 << "\t> Esc - 室\n\n\n\n\n\n"
	 << "\t\t\tணࠬ 믮 ";
    key = getch ();
    switch ( key ) {
      case 49: clrscr(); sred_vozrast (); getch();  break;
      case 50: clrscr(); modif (); getch();  break;
      case 51: clrscr(); dop (); getch (); break;
      case 52: clrscr(); udalenie (); getch ();  break;
      case 53: clrscr(); opr_vozrast (); getch ();  break;
      case 54: clrscr (); sub_menu (); break;
      case 55: clrscr (); sort_otdels (); getch (); break;
      case 13: clrscr (); view_otdel (); getch (); break;
    }
  } while ( key != 27 );
  window ( 1, 1, 80, 25 ); textbackground ( 0 ); textcolor ( 7 ); clrscr ();
  _setcursortype ( _NORMALCURSOR ); screen.close (); res_file.close ();
  refresh_textfile ();
  for ( int i = 0; i < dep_count; i ++ )
    remove ( bin_filename ( dep_list [ i ] ) );
  delete dep_list;
}